#!/usr/bin/perl
use POSIX qw(strftime);
use File::Find;
use CGI qw/-no_xhtml :standard/;
use CGI::Carp qw(fatalsToBrowser);

# create the HTTP header
print header(-charset => 'windows-1251',
             -expires=>'+30s'),
      start_html(' ,   sitemap.xml');

$pri = "../../sitemap.xml";
open(PH, ">:utf8", $pri) or die "can't open $pri: $!";
print PH "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
print PH "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";

#  URL     my $core_site,   "http://www.site.ru/"
my $core_site = "http://blankinew.narod.ru/";
#    . sitemap-readme.txt

#   ,     sitemap.xml (  )
#  my @exl_ext   ,     sitemap.xml
my @exl_ext = qw(xml css js);
#  my @exl_name_dir  ,       sitemap.xml
my @exl_name_dir = qw(image/);
#  my @exl_name_file   ,     sitemap.xml
my @exl_name_file = qw(blankinew blankinew_set_priv test file_from_dir counter);

#  my @condition_all  :
#            
my @condition_all = ("doc zip rar|0.8 yearly", "gif|0.7 yearly");
#  my @condition_dir   :
#             
my @condition_dir = ("log/tmp/|txt|0.1 daily", "arj/|zip rar|0.5 never");

my $core_core = "../../";


find(\&wanted, $core_core);
sub wanted {
#  $freg      
my $freg = "monthly";
#  $num_prior    
my $num_prior = 0.9;
my ($name_file, $extend) = split /\./, $_;
my $dirc = $File::Find::dir . "/";
$dirc =~ s#$core_core#$core_site#;
unless ( ( -d $_ ) || ( grep { $dirc =~ /$_/ } @exl_name_dir ) ||
                      ( grep {$extend eq $_} @exl_ext ) ||
                      ( grep {$name_file eq $_} @exl_name_file ) ) {
my $date = strftime "%Y-%m-%dT%H:%M:%S+00:00", localtime((stat($_))[9]);

foreach $find_condition_all (@condition_all) {
my @string_cond_all = split /\|/, $find_condition_all;
my @ext_cond_all = split " ", @string_cond_all[0];
if ( grep {$extend eq $_} @ext_cond_all )  {
($num_prior, $freg) = split " ", $string_cond_all[1];
}
}

foreach $find_condition_dir (@condition_dir) {
my @string_cond_dir = split /\|/, $find_condition_dir;
my @ext_cond_dir = split " ", @string_cond_dir[1];
if ( ($dirc eq ($core_site . $string_cond_dir[0])) &&
     (( grep {$extend eq $_} @ext_cond_dir ) || (!@string_cond_dir[1]))  )  {
($num_prior, $freg) = split " ", $string_cond_dir[2];
}
}

my $ch_fr = "<changefreq>$freg</changefreq>\n";
my $prior = "<priority>$num_prior</priority>\n";
print PH "<url>\n<loc>", $dirc, $_, "</loc>\n<lastmod>", $date, "</lastmod>\n", $ch_fr, $prior, "</url>\n";
print $dirc, $_, "  ", $date, "  ", $ch_fr, "  " , $prior, "<br>\n";
                 }
           }
print PH "</urlset>";
close PH;
print $core_core;
print end_html;
exit;
